# bladerunner

bladerunner is a rewrite of [middler](https://www.npmjs.org/package/middler) which
is additionally usable for generic stack-based transforms (in a non-HTTP scenario):

```js
var bladerunner = require('bladerunner');

var runner = bladerunner()
  .use(function (req, res, next) {
    // do something with req/res and call next()
    next();
  })
  .use('/alcohol/*', function (req, res, next) {
    res.isAlcohol = true;
    next();
  })

runner.run('/alcohol/bud?lite=true', function (err, res) {
  assert.ifError(err);
  // res has been run through the stack
  // res = {isAlcohol: true}
  done();
});
```

---

### Developed by [Terra Eclipse](http://www.terraeclipse.com)

Terra Eclipse, Inc. is a nationally recognized political technology and
strategy firm located in Aptos, CA and Washington, D.C.

### License: MIT

- Copyright (C) 2014 Carlos Rodriguez (http://s8f.org/)
- Copyright (C) 2014 Terra Eclipse, Inc. (http://www.terraeclipse.com/)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the &quot;Software&quot;), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

